package jp.agentec.sinaburocast.service;

import java.io.UnsupportedEncodingException;

import javax.annotation.Resource;
import javax.mail.MessagingException;

import jp.agentec.sinaburocast.common.SinaburoConstant;
import jp.agentec.sinaburocast.common.util.SinaburoUtil;
import jp.agentec.sinaburocast.entity.Member;
import jp.agentec.sinaburocast.entity.PasswordMailSend;
import junit.framework.TestSuite;

import org.apache.commons.lang.RandomStringUtils;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.seasar.dao.unit.S2DaoTestCase;

public class PasswordMailSendServiceTest extends S2DaoTestCase {

	@Resource
	private PasswordMailSendService passwordMailSendService;

	@Resource
	private MemberService memberService;

	public PasswordMailSendServiceTest(String string) {
		super(string);
	}

	public static TestSuite suite() {
		TestSuite suite = new TestSuite("PasswordMailSendServiceTest");
		suite.addTest(new PasswordMailSendServiceTest("insertPasswordMailSendTx"));
		suite.addTest(new PasswordMailSendServiceTest("findById"));
		suite.addTest(new PasswordMailSendServiceTest("findAllOrderById"));
		suite.addTest(new PasswordMailSendServiceTest("insertPasswordMailSendLogicTx"));
		suite.addTest(new PasswordMailSendServiceTest("findByOneTypeTicket"));
		suite.addTest(new PasswordMailSendServiceTest("findBymemberId"));
		suite.addTest(new PasswordMailSendServiceTest("findBymemberIdList"));

		return suite;
	}

	public void insertPasswordMailSendTx(){
		PasswordMailSend passwordMailSend = new PasswordMailSend();
		//passwordMailSend.passwordMailSendId = null;
		passwordMailSend.memberId = 1;
		passwordMailSend.expiredDate = SinaburoUtil.getTimestamp();
		passwordMailSend.onetimeTicket = RandomStringUtils.randomAlphanumeric(30);

	    passwordMailSendService.insertPasswordMailSend(passwordMailSend, "TESTCLASS01");
	}
	public void findById(){
	    System.out.println(passwordMailSendService.findById(1));
	}
	public void findAllOrderById(){
	    System.out.println(passwordMailSendService.findAllOrderById());
	}
	public void insertPasswordMailSendLogicTx()throws MessagingException, UnsupportedEncodingException{
		Member member = memberService.findById(1);
		String email = "choi-c@agentec.jp";
	    System.out.println(passwordMailSendService.insertPasswordMailSendLogic(member, email));
	}
	public void findByOneTypeTicket(){
	    System.out.println(passwordMailSendService.findByOneTypeTicket("1WKkg2TEIGMDS3DJdsqcDfWiCk6W8a",SinaburoConstant.MailType.PASSWORD));
	}

//	public void findBymemberId(){
//	    System.out.println(passwordMailSendService.findBymemberId(1));
//	}
	public void findBymemberIdList(){
	    System.out.println(passwordMailSendService.findBymemberIdList(1));
	}

	/**
	 * @throws java.lang.Exception
	 */
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
        include("app.dicon");
	}

	/**
	 * @throws java.lang.Exception
	 */
	@After
	public void tearDown() throws Exception {
	}



}
